#lang racket

(provide Model<%> Controller<%> Timer<%> World<%>)

;; a Model must respond to on-tick and subscribe.

;; different models may have different data definitions for
;; PublishedValue. 

(define Model<%> 
  (interface ()
    on-tick ;  () -> Void
    subscribe  ; (PublishedValue -> Void) -> Void
    ))
    
;; Controllers respond to mouse and keyboard

(define Controller<%>
  (interface ()
    add-to-scene  ; Scene -> Scene
    on-mouse      ; Integer Integer MouseEvent -> Void
    on-key        ; KeyEvent -> Void
    ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; specifics for us:

;; A Timer<%> is a Model<%> that also responds to a set-time! command.

(define Timer<%>
  (interface
    (Model<%>)  ; PublishedValue = Integer
    set-time!   ; Integer[0,100] -> Void
    ))

(define World<%>
  (interface ()
    on-tick    ; -> Void
    on-mouse   ; Integer Integer MouseEvent -> Void
    on-display ; -> Scene
    on-key     ; KeyEvent -> Void
    ))

    