#lang racket

;; countdown timer with many viewer/controllers

;; INSTRUCTIONS:

;; run with (run 0.25)

;; "n" starts a slider visualization of the timer at the current mouse position  
;; Dragging the slider changes the value of the timer.
;; Dragging the visualization by any point other than the slider drags
;; the entire visualization.

;; "d" starts a digital simulation of the timer at the current mouse
;; position. 
;; "+" with mouse near a digital display increments the timer by 5.
;; "-" with mouse near a digital display decrements the timer by 5.

;; Note: this behavior is actually implemented in world.rkt


(require "world.rkt")
(require "timer.rkt")

(require 2htdp/universe)

;; Run a world at rate secs/tick.  The initial world has just a timer in it.
(define (run rate)
  (local
    ((define initial-world
       (new World% [timer (new Timer% [n 100][rate (/ 1 rate)])])))
    (big-bang initial-world
      (on-tick
        (lambda (w) (send w on-tick) w)
        rate)
      (on-mouse 
        (lambda (w mx my mev) (send w on-mouse mx my mev) w))
      (on-key
        (lambda (w kev) (send w on-key kev) w))
      (on-draw
        (lambda (w) (send w on-display))))))

